#include <stdio.h>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include "ast.hpp"
#include "tangent_linear_code.hpp"
#include "adjoint_code_joint.hpp"
#include "dcc.hpp"

using namespace std;

extern void lexinit(FILE*);
extern int yyparse(void);

// internal representation is global
ast the_ast;

// prefixes for auxiliary variables generated by compiler
string tl_var_prefix, adj_var_prefix, sac_var_prefix;
// sizes of stacks
int css, dss;

string amode_var_name;

int main(int argc, char* argv[]) {
  if (argc != 4) {
    exit(EXIT_FAILURE);
  }

  int diff_mode; 
  string diff_order; 
  string sac_var_base; 

  diff_mode = atoi(argv[2]);
  diff_order = argv[3];
  amode_var_name = "a" + diff_order + "_mode";
  sac_var_prefix = "v" + diff_order;
  css = 1000000; 
  dss = 100000;

  // open source file
  FILE *source;
  if (string(argv[1]) == "-") {
    source = stdin;
  } else {
    source = fopen(argv[1],"r");
    if (source == NULL) {
      perror("Failed to open input");
      exit(EXIT_FAILURE);
    }
  }

  // parse
  lexinit(source);
  int parse_result = yyparse();
  // close source file
  fclose(source);
  if (parse_result != 0) return parse_result;

  if (diff_mode == 0) { // just unparse
    the_ast.unparse(cout);
    return EXIT_SUCCESS;
  } else if (diff_mode == 1) { // build tangent linear code
    tl_var_prefix = "t" + diff_order + "_";
    tangent_linear_code tlc;
    tlc.build(cout);
    return EXIT_SUCCESS;
  } else if (diff_mode == 2) { // build adjoint code (joint mode)
    adj_var_prefix = "a" + diff_order + "_";
    adjoint_code_joint ac;
    ac.build(argv[1], cout);
    return EXIT_SUCCESS;
  }
  return 2;
}
